NodeJs之数据库卓殊管理,浅谈NodeJs之数据库至极管理

By admin in 4858美高梅 on 2019年4月22日

数据库格外


NodeJs版本:4.4.4

数据库万分


NodeJs版本:4.4.4

浅谈NodeJs之数据库卓殊管理,浅谈nodejs非常管理

本文介绍了NodeJs之数据库格外管理,分享给我们,具体如下:

NodeJs版本:4.4.4

数据库链接错误

使用nodejs管理分外最麻烦可是,那里我扬弃nodejs提供的domain和部分第三方库专门管理的东西。操作数据库是大家常用的成效。通过回调,大家那边会有这多少个err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      //connection.query(queryString, function(err, rows, fields) {

      // if (!err) {
      //   resolve(rows);
      //  } else {
      //   runtimeLog.error(err)
      //   reject(err)
      //  }
      // connection.release();
      //});
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestair")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error(err)
      })
  })
}

能够观看1个回调的地点都会有出错的恐怕。

再者那是三个模块,大家将它导出了。

此间大家有意将数据库链接的端口号填错,写成33066陆:

module.exports = {
  host:   '192.168.6.101',
  database: 'web123',
  user:   'root',
  password: 'passw0rd',
  protocol: 'mysql',
  port:   '330666',
  query:  {pool: true}
}

那样的话,在我们链接数据库的时候是会出错的。

那里大家运用了promise,所以在导出的函数中,大家采用了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

NodeJs之数据库卓殊管理,浅谈NodeJs之数据库至极管理。数据库sql语句错误

小编们修改一下代码,将数据库链接填对,修改sql语句为不当的讲话。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      connection.query(queryString, function(err, rows, fields) {
        //if (err) throw err;
        if (!err) {
          resolve(rows);
         } else {
          reject(err)
         }
        connection.release();
      });
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestairs")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error('[err]',err)
      })
  })
}

报错消息:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
 code: 'ER_BAD_FIELD_ERROR',
 errno: 1054,
 sqlState: '42S22',
 index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
  at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

能够见见错误都以经过catch抛出。

为此借使选取了Promise我们得以直接在catch中抓到上面抛出的13分。不必要再去queryPromise函数中打日志格外了。

这边有一篇stackoverflow管理错误的要命管用的问答node-js-best-practice-exception-handling

如上正是本文的全部内容,希望对大家的上学抱有补助,也指望大家多多帮助帮客之家。

本文介绍了NodeJs之数据库十分处理,分享给大家,具体如下:
NodeJs版本:四.4.肆 数据库链接错…

本文介绍了NodeJs之数据库万分管理,分享给我们,具体如下:

数据库链接错误

利用nodejs管理非凡最劳累但是,那里作者放任nodejs提供的domain和一些第二方库专门管理的事物。操作数据库是大家常用的效果。通过回调,大家那边会有繁多err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            //connection.query(queryString, function(err, rows, fields) {

            //  if (!err) {
            //      resolve(rows);
            //   } else {
            //      runtimeLog.error(err)
            //      reject(err)
            //   }
            //  connection.release();
            //});
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestair")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error(err)
            })
    })
}

可以见到三个回调的地点都会有出错的只怕。

而且那是一个模块,大家将它导出了。

此地大家有意识将数据库链接的端口号填错,写成33066六:

module.exports = {
    host:     '192.168.6.101',
    database: 'web123',
    user:     'root',
    password: 'passw0rd',
    protocol: 'mysql',
    port:     '330666',
    query:    {pool: true}
}

那样的话,在大家链接数据库的时候是会出错的。

那里咱们运用了promise,所以在导出的函数中,咱们选择了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

数据库链接错误

动用nodejs管理万分最劳苦可是,那里本身遗弃nodejs提供的domain和某些第一方库专门管理的事物。操作数据库是我们常用的意义。通过回调,我们那里会有那些err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            //connection.query(queryString, function(err, rows, fields) {

            //  if (!err) {
            //      resolve(rows);
            //   } else {
            //      runtimeLog.error(err)
            //      reject(err)
            //   }
            //  connection.release();
            //});
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestair")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error(err)
            })
    })
}

能够看到一个回调的地方都会有出错的恐怕。

再正是那是四个模块,我们将它导出了。

此处我们有意识将数据库链接的端口号填错,写成33066陆:

module.exports = {
    host:     '192.168.6.101',
    database: 'web123',
    user:     'root',
    password: 'passw0rd',
    protocol: 'mysql',
    port:     '330666',
    query:    {pool: true}
}

那样的话,在我们链接数据库的时候是会出错的。

那边我们运用了promise,所以在导出的函数中,我们采用了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

NodeJs版本:4.4.4

数据库sql语句错误

大家修改一下代码,将数据库链接填对,修改sql语句为不当的言语。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            connection.query(queryString, function(err, rows, fields) {
                //if (err) throw err;
                if (!err) {
                    resolve(rows);
                 } else {
                    reject(err)
                 }
                connection.release();
            });
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestairs")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error('[err]',err)
            })
    })
}

报错音讯:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
  code: 'ER_BAD_FIELD_ERROR',
  errno: 1054,
  sqlState: '42S22',
  index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
    at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

能够看来错误都是因此catch抛出。

4858美高梅 ,于是假设运用了Promise咱俩得以平昔在catch中抓到下边抛出的卓殊。不要求再去queryPromise函数中打日志相当了。

此处有一篇stackoverflow处理错误的要命实用的问答node-js-best-practice-exception-handling

数据库sql语句错误

我们修改一下代码,将数据库链接填对,修改sql语句为不当的讲话。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            connection.query(queryString, function(err, rows, fields) {
                //if (err) throw err;
                if (!err) {
                    resolve(rows);
                 } else {
                    reject(err)
                 }
                connection.release();
            });
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestairs")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error('[err]',err)
            })
    })
}

报错音信:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
  code: 'ER_BAD_FIELD_ERROR',
  errno: 1054,
  sqlState: '42S22',
  index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
    at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

能够见到错误都以通过catch抛出。

就此1旦运用了Promise大家能够一向在catch中抓到上边抛出的卓殊。不须要再去queryPromise函数中打日志格外了。

此间有一篇stackoverflow处理错误的丰硕实用的问答node-js-best-practice-exception-handling

数据库链接错误

利用nodejs管理10分最麻烦可是,那里我甩掉nodejs提供的domain和一部分第2方库专门管理的东西。操作数据库是大家常用的功效。通过回调,大家那边会有不少err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      //connection.query(queryString, function(err, rows, fields) {

      // if (!err) {
      //   resolve(rows);
      //  } else {
      //   runtimeLog.error(err)
      //   reject(err)
      //  }
      // connection.release();
      //});
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestair")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error(err)
      })
  })
}

能够见到二个回调的地点都会有疏失的或然。

并且那是一个模块,大家将它导出了。

那边大家有意识将数据库链接的端口号填错,写成33066陆:

module.exports = {
  host:   '192.168.6.101',
  database: 'web123',
  user:   'root',
  password: 'passw0rd',
  protocol: 'mysql',
  port:   '330666',
  query:  {pool: true}
}

那样的话,在我们链接数据库的时候是会出错的。

此间大家利用了promise,所以在导出的函数中,大家运用了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

数据库sql语句错误

我们修改一下代码,将数据库链接填对,修改sql语句为不当的讲话。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
  return new Promise(function(resolve, reject) {
    pool.getConnection(function(err, connection) {

      connection.query(queryString, function(err, rows, fields) {
        //if (err) throw err;
        if (!err) {
          resolve(rows);
         } else {
          reject(err)
         }
        connection.release();
      });
    })
  })
}

module.exports = function() {
  return new Promise(function(resolve, reject) {

    queryPromise("select * from wb123_home_map GROUP BY onestairs")
      .then(function(results){
        resolve(results);

      })
      .catch(function(err){
        runtimeLog.error('[err]',err)
      })
  })
}

报错消息:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
 code: 'ER_BAD_FIELD_ERROR',
 errno: 1054,
 sqlState: '42S22',
 index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
  at Query.Sequence._packetToError (E:\zz\zz_wb123\manage\trunk\code\nod
....

能够观察错误都以由此catch抛出。

所以壹旦应用了Promise我们得以向来在catch中抓到下边抛出的可怜。不要求再去queryPromise函数中打日志万分了。

那里有一篇stackoverflow管理错误的尤其实用的问答node-js-best-practice-exception-handling

以上正是本文的全体内容,希望对大家的求学抱有帮助,也期望大家多多帮衬脚本之家。

你也许感兴趣的作品:

  • Nodejs异步回调的优雅管理方式
  • 剖析Node.js至极处理中domain模块的行使形式
  • 使用nodejs中httpProxy代理时候出现40四尤其的缓慢解决办法
  • Node.js
    异步至极的拍卖与domain模块解析
  • NodeJS管理Express中异步错误
  • 行使Raygun对Node.js应用举办错误管理的不二秘籍
  • Node错误管理笔记之挖坑类别教程
  • Nodejs异步回调之万分管理实例分析

发表评论

电子邮件地址不会被公开。 必填项已用*标注

网站地图xml地图
Copyright @ 2010-2019 美高梅手机版4858 版权所有